#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
#include <string>
#include "absent.h"

int get(int bit, std::vector<int> pos, std::vector<int> values) {
  if ((int) values.size() == 1) {
    return values[0];
  }
  int cnt[2];
  cnt[0] = cnt[1] = 0;
  std::vector<int> keep((int) pos.size());
  for (int i = 0; i < (int) pos.size(); i++) {
    int x = get_bit(pos[i], bit);
    cnt[x]++;
    keep[i] = x;
  }
  for (int x : values) {
    cnt[x >> (10 - bit) & 1]--;
  }
  int care = (cnt[0] == 0? 1 : 0);
  std::vector<int> newPos, newValues;
  for (int x : values) {
    if (care == ((x >> 10 - bit) & 1)) {
      newValues.push_back(x);
    }
  }
  for (int i = 0; i < (int) pos.size(); i++) {
    if (keep[i] == care) {
      newPos.push_back(pos[i]);
    }
  }
  return get(bit - 1, newPos, newValues);
}

void play(int n) {
  std::vector<int> cand, values;
  for (int i = 1; i <= n - 1; i++) {
    cand.push_back(i);
  }
  values = cand;
  values.push_back(n);
  int x = get(10, cand, values);
  submit_absent(x);
}
