#ifndef ABSENT_H_INCLUDED
#define ABSENT_H_INCLUDED
#include <bits/stdc++.h>

using namespace std;

const int NMAX = 1000;

bool suspect[NMAX + 1];

int bits[NMAX + 1];

int missing = 0;

int actualBits( int n, int bit ) {
    int ans = 0;
    for ( int i = 1; i <= n; i ++ ) {
        if ( ((i & (bit - 1)) ^ missing) == 0 && ( i & bit ) == bit ) ans ++;
    }
    return ans;
}

bool get_bit(int i, int j);
void submit_absent(int x);

void play(int n) {
    for ( int i = 1; i < n; i ++ ) suspect[i] = true;

    for ( int bit = 10; bit >= 1; bit -- ) {
        int cntBits = 0;
        for ( int i = 1; i < n; i ++ ) {

            if ( suspect[i] ) {
                bits[i] = get_bit( i, bit );
                cntBits += bits[i];
            }
        }
        if ( cntBits == actualBits( n, ( 1 << (10 - bit ) ) ) ) {
            for ( int i = 1; i < n; i ++ ) {
                if ( bits[i] == true ) suspect[i] = false;
            }
        } else {
            missing ^= ( 1 << ( 10 - bit ) );
            for ( int i = 1; i < n; i ++ ) {
                if ( bits[i] == false ) suspect[i] = false;
            }
        }
    }

    submit_absent( missing );
}


#endif
