#ifndef ABSENT_H_INCLUDED
#define ABSENT_H_INCLUDED

void play(int n);

bool get_bit(int i, int j);
void submit_absent(int x);

#include <vector>

using namespace std;

void play(int N) {
    vector<int> indices;
    indices.reserve(N - 1);
    for (int i = 1; i <= N - 1; ++i)
        indices.push_back(i);

    int ans = 0;
    for (int bit = 1; bit <= 10; ++bit) {
        int actual_cnt = 0;
        for (int x = max(1, ans); x < min(N + 1, ans + (1 << (11 - bit))); ++x) {
            if (x & (1 << (10 - bit))) ++actual_cnt;
        }

        vector<int> zeroes, ones;

        for (int i : indices)
            if (get_bit(i, bit) == 0) zeroes.push_back(i);
            else ones.push_back(i);

        if (ones.size() == actual_cnt) {
            indices = zeroes;
        } else {
            indices = ones;
            ans += (1 << (10 - bit));
        }
    }
    submit_absent(ans);
}

#endif
