#include <iostream>
#include <vector>

using namespace std;

#define int long long

void solve() {
    string s;
    cin >> s;
    int n = s.size();
    vector<int> dp(n + 1);
    for (int i = 0; i <= n; ++i) dp[i] = i;
    auto is_p = [&](int l, int r) -> bool {
        for (int i = 0; i < (r - l + 1) / 2; ++i) {
            if (s[i + l] != s[r - i]) return 0;
        }
        return 1;
    };
    for (int i = 1; i <= n; ++i) {
        for (int j = 0; j < i; ++j) {
            if (dp[j] + 1 >= dp[i]) continue;
            if (is_p(j, i - 1)) dp[i] = dp[j] + 1;
        }
    }
    cout << dp[n] << '\n';
}

signed main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int tc = 1;
    // cin >> tc;
    for (int t = 1; t <= tc; ++t) {
        solve();
    }
}