#include <iostream>
#include<string>
#include<cmath>
#include<map>
#include<iomanip>
#include<algorithm>
#include<vector>
#include<set>
#include<cstdio>
#include<stack>
#include<ctime>
#include<queue>
#include<deque>
#include<bitset>
#include<random>
#include<fstream>
#include<unordered_map>
#include<unordered_set>
using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;
using uint = unsigned int;
using dbl = double;

# define all(x) x.begin(), x.end()
# define rall(x) x.rbegin(), x.rend()

ll gcd(ll a, ll b) {
    return b == 0 ? a : gcd(b, a % b);
}
ll lcm(ll a, ll b) {
    return a / gcd(a, b) * b;
}
ll bpow(ll a, ll n) {
    return n == 0 ? 1 : n % 2 ? bpow(a, n - 1) * a : bpow(a * a, n / 2);
}
ll bpowm(ll a, ll n, ll m) {
    return n == 0 ? 1 : n % 2 ? bpowm(a, n - 1, m) * a % m : bpowm(a * a % m, n / 2, m);
}
mt19937 mt(time(0));
const int N = 10000 + 2, inf = 1e9 + 100, mod2 = 1e9 + 7, mod = 998244353, P = 257;
const ll llinf = 4e18 + 1000;
int n, dp[N], maxp_ch[N], maxp_nc[N];
char a[N];

void solve() {
    string s;
    cin >> s;
    n = s.size();
    for (int i = 0; i < n; ++i) a[i] = s[i];
    for (int i = 0; i < n; ++i) {
        maxp_nc[i] = 1;
        for (; i - maxp_nc[i] >= 0 && i + maxp_nc[i] < n && a[i - maxp_nc[i]] == a[i + maxp_nc[i]]; ++maxp_nc[i]);
        maxp_ch[i] = 0;
        for (; i - maxp_ch[i] >= 0 && i + maxp_ch[i] + 1 < n && a[i - maxp_ch[i]] == a[i + 1 + maxp_ch[i]]; ++maxp_ch[i]);
    }
    fill(dp, dp + n + 1, inf);
    dp[0] = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i; j * 2 - i >= 0; --j) {
            if (j + maxp_nc[j] >= i) dp[i + 1] = min(dp[i + 1], dp[j * 2 - i] + 1);
        }
        for (int j = i - 1; j * 2 - i + 1 >= 0; --j) {
            if (j + maxp_ch[j] >= i) dp[i + 1] = min(dp[i + 1], dp[j * 2 - i + 1] + 1);
        }
    }
    cout << dp[n];
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    //freopen("coloring.in", "r", stdin);
    //freopen("coloring.out", "w", stdout);

    //ld time1 = clock();

    int tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
        cout << '\n';
        cout.flush();
    }

    //ld time2 = clock();
    //cerr << "\n\nTIME: " << (time2 - time1) / CLOCKS_PER_SEC;
    return 0;
}
