#include <bits/stdc++.h>

using namespace std;
using vi = vector<int>;

const int INF = 1e9;

int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    string s;
    int n;
    cin >> s;
    n = (int)s.size();
    if(n == 0) {
        cout << 0 << "\n";
        return 0;
    }

    vi DP(n + 1, 0);
    vector<vector<bool> > Pal(n, vector<bool>(n, false));
    for(int i = 0; i < n; ++i) {
        Pal[i][i] = 1;
        if(i + 1 < n)
            Pal[i][i + 1] = s[i] == s[i + 1];
    }

    for(int l = 3; l <= n; ++l ) {
        for(int i = 0; i < n; ++i) {
            j = i + l - 1;
            if(j >= n) break;
            Pal[i][j] = Pal[i + 1][j - 1] && (s[i] == s[j]);
        }
    }

    for(int i = 1; i <= n; ++i) DP[i] = INF;
    
    for(int i = 0; i < n; ++i) {
        for(int j = i + 1; j <= n; ++j) {
            if(Pal[i][j - 1])
                DP[j] = min(DP[j], DP[i] + 1);
        }
    }

    cout << DP.back() << "\n";

    return 0;
}