# include <bits/stdc++.h>
# define ull unsigned long long
using namespace std;

const int MAXN = 10001;
const int INF = 1e9;
string s;
int n;
int dp[MAXN];
bool Visited[MAXN];
bool Check(int l, int r)
{
    while(l <= r)
    {
        if(s[l] != s[r]) return false;
        l++;
        r--;
    }

    return true;
}

int Calc(int i)
{
    if(i < 0) return 0;
    if(Visited[i]) return dp[i];
    Visited[i] = true;
    dp[i] = INF;

    for(int j = i; j >= 0; j--)
    {
        if(Check(j, i))
        {
            dp[i] = min(dp[i], Calc(j - 1) + 1);
        }
    }

    return dp[i];
}

void Upgrade_Speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> s;
    n = (int)s.size();
}

void Solve()
{
    cout << Calc(n - 1);
}

int main()
{
    Upgrade_Speed();
    Read();
    Solve();
    return 0;
}
