#include<iostream>

#define endl '\n'

using namespace std;

typedef long long ll;

const int MAXN = 1e3 + 10;
const int INF = 1e9 + 10;

unsigned short int pal[MAXN][MAXN];

string s;
int n;

int dp[MAXN];

void read()
{
    cin >> s;
    n = s.size();
}

bool f(int left, int right)
{
    if(left >= right)
        return true;

    if(pal[left][right] != 2)
        return pal[left][right];

    return pal[left][right] = (s[left] == s[right] && f(left + 1, right - 1));
}

void solve()
{
    for(int i = 0; i < n; i++)
    {
        for(int j = 0; j < n; j++)
        {
            pal[i][j] = 2;
        }
        dp[i] = INF;
    }

    dp[n] = 0;

    for(int i = n - 1; i >= 0; i--)
    {
        for(int j = i; j < n; j++)
        {
            if(!f(i, j))
                continue;
                
            dp[i] = min(dp[i], 1 + dp[j + 1]);
        }
    }

    cout << dp[0] << endl;
}

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();

    return 0;
}