#include<iostream>
#include<string>
#include<vector>
#include<algorithm>

#define endl '\n'

using namespace std;

typedef long long ll;

vector < int > ch1, ch2;
int maxsz;
string s1, s2;

void read()
{
    cin >> s1 >> s2;

    int sz1 = s1.size();
    int sz2 = s2.size();

    maxsz = max(sz1, sz2) + 1;
    ch1.resize(maxsz + 2, 0);
    ch2.resize(maxsz + 2, 0);

    reverse(s1.begin(), s1.end());
    reverse(s2.begin(), s2.end());

    for(int i = 0; i < sz1; i++)
    {
        ch1[i] = s1[i] - '0';
    }

    for(int i = 0; i < sz2; i++)
    {
        ch2[i] = s2[i] - '0';
    }
}

void solve()
{
    vector < int > result;
    result.resize(maxsz + 2, 0);

    if(s1.size() < s2.size())
        swap(s1, s2);

    for(int i = 0; i <= maxsz; i++)
    {
        int p = (result[i] + ch1[i] + ch2[i]) / 10;
        int w = (result[i] + ch1[i] + ch2[i]) % 10;

        result[i + 1] += p;
        result[i] = w;
    }

    bool started = false;

    string ans = "";

    for(int i = maxsz + 1; i >= 0; i--)
    {
        if(!started)
        {
            if(result[i] > 0)
            {
                ans += (result[i] + '0');
                started = true;
            }
                
            continue;
        }

        ans += (result[i] + '0');
    }

    cout << ans << endl;
}

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();

    return 0;
}