#include <bits/stdc++.h>

using namespace std;

const int maxn = 10005;
const long long mod = 1e9 + 7;
const long long BASE = 131;

string s;
string t;
long long pref[maxn], pwr[maxn];

bool check(int l, int r)
{
    while (l < r)
    {
        if (s[l] != s[r]) return false;
        ++l;
        --r;
    }

    return true;
}

void init()
{
    pwr[0] = 1;
    for (int i = 1; i <= t.size(); ++i)
    {
        pwr[i] = (pwr[i - 1] * BASE) % mod;
        pref[i] = (pref[i - 1] * BASE + t[i]) % mod;
    }
}

bool checkHash(int l, int r)
{
    r = s.size() - r;
    l = s.size() - l;
    swap(l, r);
    char symb = (l == 0 ? 0 : t[l - 1]);
    return (pref[r] - pwr[r - l + 1] * symb + mod * mod) % mod;
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> s;
    t = s.size();
    reverse(t.begin(), t.end());
    init();

    long long ans = 0;

    for (int i = 0; i < s.size(); ++i)
    {
        long long curr = 0;

        for (int j = s.size() - 1; j >= i; --j)
        {
            if (check(i, j))
            {
                i = j;
                ++ans;
                break;
            }
        }
    }

    cout << ans << endl;

    return 0;
}
