#include <iostream>
#include <string>
#include <stack>

int min_num[100000];
std::string t;

//int compute(int a) {
//    if (min_num[a] != -69420) return min_num[a];
//
//    std::stack <char> s;
//    int res = compute(a-1) + 1;
//    for (int i = a; i >= 0; i--) {
//        if (s.empty()) {
//            s.push(t[i]);
//        } else {
//            if (s.top() != t[i]) {
//                s.push(t[i]);
//            } else {
//                s.pop();
//            }
//        }
//
//        if (s.empty() == 0 || (s.size() == 1 && s.top() == t[(a+i)/2])) {
//            res = std::min(res, compute(i-1)+1);
//        }
//    }
//
//    min_num[a] = res;
//    return res;
//}

bool is_palindrome(int a, int b) {
    while (a <= b) {
        if (t[a] != t[b]) return false;
        a++; b--;
    }
    return true;
}

int compute(int a) {
    if (min_num[a] != -69420) return min_num[a];

    int res = compute(a-1) + 1;
    for (int i = a; i >= 0; i--) {

        if (is_palindrome(i, a)) {
            res = std::min(res, compute(i-1)+1);
        }
    }

    min_num[a] = res;
    return res;
}

int main() {
    std::cin >> t;

    for (int i = 0; i < 100000; i++) {
        min_num[i] = -69420;
    }
    min_num[0] = 1;

    std::cout << compute(t.size() - 1);
}
