#include<bits/stdc++.h>
#define MAXN 10007
using namespace std;

const long long mod[2]={1e9+7,1e9+9};
long long power[MAXN][2];

struct hesh{
    int len;
    long long h[2];

    void add(char x){
        len++;
        h[0]*=27; h[0]+=x-'0'+1; h[0]%=mod[0];
        h[1]*=27; h[1]+=x-'0'+1; h[1]%=mod[1];
    }

    inline friend bool operator == (hesh fr,hesh sc){
        return fr.len==sc.len and fr.h[0]==sc.h[0] and fr.h[1]==sc.h[1];
    }

    inline friend hesh operator - (hesh fr,hesh sc){
        return {fr.len-sc.len,(fr.h[0]-sc.h[0]*power[fr.len-sc.len][0]+mod[0]*mod[0])%mod[0] , (fr.h[1]-sc.h[1]*power[fr.len-sc.len][1]+mod[1]*mod[1])%mod[1] };
    }
};

hesh pref[MAXN],suff[MAXN];

bool palindrome(int l,int r){
    return pref[r]-pref[l-1] == suff[l] - suff[r+1];
}

int n;
char c[MAXN];
int dp[MAXN];

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>(c+1);
    n=strlen(c+1);

    power[0][0]=power[0][1]=1;
    for(int i=1;i<=n;i++){
        power[i][0]=(power[i-1][0]*27)%mod[0];
        power[i][1]=(power[i-1][1]*27)%mod[1];
    }

    for(int i=1;i<=n;i++){
        pref[i]=pref[i-1];
        pref[i].add(c[i]);
    }

    for(int i=n;i>=1;i--){
        suff[i]=suff[i+1];
        suff[i].add(c[i]);
    }

    for(int i=1;i<=n;i++){
        dp[i]=2*n;

        for(int f=i;f>=1;f--){
            if(palindrome(f,i))dp[i]=min(dp[i],dp[f-1]+1);
        }
    }

    cout<<dp[n]<<"\n";

    return 0;
}