#include<bits/stdc++.h>
#define MAXN 10007
using namespace std;

const long long mod=1e9+7;
long long power[MAXN];

struct hesh{
    int len;
    long long h;

    void add(char x){
        len++;
        h*=27; h+=x-'0'+1; h%=mod;
    }

    inline friend bool operator == (hesh fr,hesh sc){
        return fr.len==sc.len and fr.h==sc.h;
    }

    inline friend hesh operator - (hesh fr,hesh sc){
        return {fr.len-sc.len,(fr.h-sc.h*power[fr.len-sc.len]+mod*mod)%mod };
    }
};

hesh pref[MAXN],suff[MAXN];

bool palindrome(int l,int r){
    return pref[r]-pref[l-1] == suff[l] - suff[r+1];
}

int n;
char c[MAXN];
int dp[MAXN];

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>(c+1);
    n=strlen(c+1);

    power[0]=1;
    for(int i=1;i<=n;i++){
        power[i]=(power[i-1]*27)%mod;
    }

    for(int i=1;i<=n;i++){
        pref[i]=pref[i-1];
        pref[i].add(c[i]);
    }

    for(int i=n;i>=1;i--){
        suff[i]=suff[i+1];
        suff[i].add(c[i]);
    }

    for(int i=1;i<=n;i++){
        dp[i]=2*n;

        for(int f=min(i-1,100);f>=1;f--){
            if(palindrome(f,i))dp[i]=min(dp[i],dp[f-1]+1);
        }

        for(int f=i;f>=max(1,i-100);f--){
            if(palindrome(f,i))dp[i]=min(dp[i],dp[f-1]+1);
        }
    }

    cout<<dp[n]<<"\n";

    return 0;
}