#include <bits/stdc++.h>

using namespace std;

const int nmax = 1e4;
const int Mod = 1e9 + 7;
const int b = 27;

char s[nmax + 5];

int h[nmax + 5], hr[nmax + 5];
int put[nmax + 5];

int dp[nmax + 5];

int get_hash(int st, int dr)
{
    return (h[dr] - 1LL * h[st - 1] * put[dr - st + 1] % Mod + Mod) % Mod;
}

int get_hash_rev(int st, int dr)
{
    return (hr[st] - 1LL * hr[dr + 1] * put[dr - st + 1] % Mod + Mod) % Mod;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin>>(s + 1);
    int n = strlen(s + 1);
    put[0] = 1;
    for(int i=1;i<=n;i++)
    {
        put[i] = 1LL * put[i - 1] * b % Mod;
    }
    for(int i=1;i<=n;i++)
    {
        h[i] = (1LL * h[i - 1] * b % Mod + (s[i] - 'a' + 1)) % Mod;
    }
    for(int i=n;i>=1;i--)
    {
        hr[i] = (1LL * hr[i + 1] * b % Mod + (s[i] - 'a' + 1)) % Mod;
    }
    for(int i=1;i<=n;i++)
    {
        dp[i] = 1 + dp[i - 1];
        for(int j=i-1;j>=0;j--)
        {
            if(get_hash(j + 1, i) == get_hash_rev(j + 1, i))
            {
                dp[i] = min(dp[i], 1 + dp[j]);
            }
        }
    }
    cout<<dp[n]<<'\n';
    return 0;
}
