#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
#include <string>

using ll = long long;
using i128 = __int128;

int main() {
  std::string s, t;
  std::cin >> s >> t;

  if (s.size() < t.size()) {
    std::swap(s, t);
  }
  while (t.size() < s.size()) {
    t = "0" + t;
  }

  std::vector<int> answer;
  int cur = 0;
  for (int i = (int) s.size() - 1; i >= 0; i--) {
    cur += s.back() - '0';
    cur += t.back() - '0';
    answer.push_back(cur % 10);
    cur /= 10;
  }

  if (cur != 0) {
    answer.push_back(cur);
  }

  std::reverse(answer.begin(), answer.end());
  for (int x : answer) {
    std::cout << x;
  }
  return 0;
}