#include <bits/stdc++.h>

using namespace std;
using vi = vector<int>;

const int INF = 1e9;

int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    string s;
    int n;
    cin >> s;
    n = (int)s.size();

    vi DP(n + 1, 0);
    vector<vi> Pal(n, vi(n, 0));
    for(int i = 0; i < n; ++i) {
        Pal[i][i] = 1;
        if(i + 1 < n)
            Pal[i][i + 1] = s[i] == s[i + 1];
    }
    for(int i = 0; i < n; ++i) {
        for(int j = i + 2; j < n; ++j) {
            Pal[i][j] = Pal[i + 1][j - 1] && (s[i + 1] == s[j - 1]);
        }
    }

    for(int i = 1; i <= n; ++i) DP[i] = INF;
    
    for(int i = 0; i < n; ++i) {
        for(int j = 1; j <= n; ++j) {
            if(Pal[i][j - 1])
                DP[j] = min(DP[j], DP[i] + 1);
        }
    }

    cout << DP.back() << "\n";

    return 0;
}