#include "absent.h"
// bool get_bit(int i, int j);
// void submit_absent(int x);

#include <vector>
#include <algorithm>
#include <iostream>

namespace __Sol__ {
	int n;

	int prune( int niv, int prefix, std::vector<int> indici ) {
		if( niv <= 0 )
			return prefix;

		// literally don't care
		int cnt[2] = { 0, 0 };
		for( int i = 1; i <= n; i++ )
			cnt[!!(i & (1 << (niv - 1)))]++;

		std::vector<int> grupe[2];
		for( int idx : indici ){
			bool bit = get_bit(idx, 10 - (niv - 1));
			cnt[bit]--;
			grupe[bit].push_back( idx );
		}

		// decide which bit we use
		// std::cout << cnt[0] << ' ' << cnt[1] << std::endl;
		bool bit = cnt[1];
		return prune( niv - 1, prefix + (int(bit) << (niv - 1)), grupe[bit] );
	}

	int get_absent( int __n ) {
		n = __n;
		std::vector<int> all;
		for( int i = 1; i < n; i++ )
			all.push_back( i );

		return prune( 10, 0, all );
	}
}

void play( int n ) { return submit_absent(__Sol__::get_absent( n )); }
