# include <iostream>
using namespace std;

const int INF=1e9;
const int MAX=1e4+11;

int n;
char a[MAX];
int dp[MAX];

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    string s;
    cin>>s;
    n=s.size();
    for(int i=1;i<=n;i++) a[i]=s[i-1];
    a[0]='#';a[n+1]='$';

    for(int i=1;i<=n;i++) dp[i]=INF;

    for(int i=1;i<=n;i++)
    {
        if(i<=n)
        {
            int l=i,r=i;
            while(a[l]==a[r])
            {
                dp[r]=min(dp[r],dp[l-1]+1);
                l--;
                r++;
            }
        }

        if(i+1<=n)
        {
            int l=i,r=i+1;
            while(a[l]==a[r])
            {
                dp[r]=min(dp[r],dp[l-1]+1);
                l--;
                r++;
            }
        }
    }

    cout<<dp[n]<<"\n";

    return 0;
}
