#include <bits/stdc++.h>

using namespace std;

const int maxn = 10005;

string s;
int dp[maxn];

bool check(int l, int r)
{
    while (l < r)
    {
        if (s[l] != s[r]) return false;
        ++l;
        --r;
    }

    return true;
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> s;
    s = "$" + s;

    long long ans = 0;

    for (int i = 1; i < s.size(); ++i)
    {
        dp[i] = 1e9;

        for (int j = i; j >= 1; --j)
        {
            if (check(j, i))
            {
                dp[i] = min(dp[i], 1 + dp[j - 1]);
            }
        }
    }

    cout << dp[s.size() - 1] << endl;

    return 0;
}
