#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN = 50;
struct LongNum
{
    int N;
    int digit[MAXN];


    LongNum(string num)
    {
        memset(digit, 0, sizeof(digit));
        N = num.size();
        for (int i = 0; i < N; i++)
        {
            digit[i] = num[N-i-1]-'0';
        }
    }
};

void add(LongNum &a, LongNum &b)
{
    int carry = 0;
    a.N = max(a.N, b.N);
    for (int i = 0; i < a.N; i++)
    {
        a.digit[i] += (b.digit[i] + carry);
        carry = a.digit[i]/10;
        a.digit[i] = a.digit[i]%10;
    }

    if (carry != 0)
        cout << carry;

    for (int i = 0; i < a.N; i++)
    {
        cout << a.digit[a.N-i-1];
    }

    cout << endl;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    string a, b;
    cin >> a >> b;

    LongNum x(a);
    LongNum y(b);

    add(x, y);

    return 0;
}
