#include <bits/stdc++.h>
using namespace std;

template< class T, class T2 > inline bool chkmin( T& a, const T2& b ){ return a > b ? a = b, 1 : 0; };
template< class T, class T2 > inline bool chkmax( T& a, const T2& b ){ return a < b ? a = b, 1 : 0; };

#ifndef LOCAL
#define cerr if(false) cerr
#endif

#define out(x) #x << " = " << x << "  "
#define endl "\n"

typedef long long ll;
typedef long double ld;

const int MAX_N = 1e6;

ll dp[MAX_N];

int main(){
#ifndef LOCAL
	std::ios_base::sync_with_stdio( false); cin.tie( NULL ); cout.tie( NULL );
#endif

	std::string s;
	std::cin >> s;

	s = "#" + s;
	dp[0] = 0;
	for( int i=1 ; i < (int)s.size() ; i++ ){
		dp[i] = 1e16;
		for( int j=i ; j >= 0 ; j-- ){

			int l = j;
			int r = i;
			int len = ( r - l + 1 );

			bool oke = true;
			for( int k=0 ; k < len ; k++ ){
				if( s[ r - k ] != s[ l + k ] ){
				       	oke = false;
					break;
				}
			}

			if( oke ){
				chkmin( dp[i], dp[j-1] + 1 );
			}
		}
		cerr << out( i ) << out( dp[i] ) << endl;
	}

	std::cout << dp[(int)s.size()-1] << endl;

	return 0;
}

