#include "absent.h"
#define MAX_QUERIES 12000

#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <bits/stdc++.h>
using namespace std;

template< class T, class T2 > inline bool chkmin( T& a, const T2& b ){ return a > b ? a = b, 1 : 0; };
template< class T, class T2 > inline bool chkmax( T& a, const T2& b ){ return a < b ? a = b, 1 : 0; };

#ifndef LOCAL
#define cerr if(false) cerr
#endif

#define out(x) #x << " = " << x << "  "
#define endl "\n"

typedef long long ll;
typedef long double ld;

const int MAXN = 1024;


void play(int N){

	std::vector< int > valid( N -1 );
	std::iota( valid.begin(), valid.end(), 1 );

	ll nas = 0;
	for( int i=10 ; i > 0 ; i-- ){
		std::vector< int > left;
		std::vector< int > right;
		for( auto j : valid ){
			int curr = get_bit( j, i );
			if( curr ) left.push_back( j );
			else right.push_back( j );
		}

		cerr << out( (int)left.size() ) << out( (int)right.size() ) << endl;
		int expSet = ( N + 1 ) / ( 1 << ( 10 - i + 1 ) );
		cerr << out( expSet ) << out( ( 1 << ( 10 - i + 1 ) ) ) << endl;
		if( (int)left.size() == expSet ){
		       	valid = right;
		}else{
			valid = left;
			nas |= ( 1 << 10 - i );
			cerr << out( nas ) << endl;
		}

		if( valid.size() == 0 ){
			if( !nas ){
				nas |= ( 1 << ( 10 - i +1 ) );
			}
		}
	}

	cerr << out( nas ) << endl;
	
	submit_absent( nas );
}
