#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>

typedef long long llong;
const int MAXN = 100000 + 10;
const int INF  = 1e9;

std::string s;
__int128 a, b;

void inp(__int128 &x)
{
    x = 0;
    std::cin >> s;
    for (const char &c : s)
    {
        x = 10 * x + (c - '0');
    }
}

void out(__int128 &x)
{
    s.clear();
    while (x)
    {
        s += char(x % 10 + '0');
        x /= 10;
    }

    std::reverse(s.begin(), s.end());
    std::cout << s << '\n';
}

void solve()
{
    a += b;
    out(a);
}

void input()
{
    inp(a);
    inp(b);
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}