#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}


const ll base = 29;
const int MAXN = 1e4 + 10;

int n;
string s;


ll fh[MAXN], bh[MAXN], pw[MAXN];
int dp[MAXN];

void solve()
{
    cin >> s;
    n = s.size();
    s = "#" + s;
    pw[0] = 1;
    for (int i = 1; i <= n; i ++)
    {
        pw[i] = pw[i - 1] * base;
        fh[i] = fh[i - 1] * base + s[i] - 'a' + 1;
    }
    for (int i = n; i > 0; i --)
    {
        bh[i] = bh[i + 1] * base + s[i] - 'a' + 1;
    }

    for (int i = 1; i <= n; i ++)
    {
        dp[i] = n + 1;
        for (int j = 1; j <= i; j ++)
        {
            ll h1 = fh[i] - fh[j - 1] * pw[i - j + 1];
            ll h2 = bh[j] - bh[i + 1] * pw[i - j + 1];

            if (h1 == h2)
                dp[i] = min(dp[i], dp[j - 1] + 1);
        }
    }

    cout << dp[n] << endl;



}

int main()
{
    solve();
    return 0;
}
